# Class Reader

java.lang.Object
java.io.Reader

All Implemented Interfaces:
  `java.lang.AutoCloseable`

Direct Known Subclasses:
  `InputStreamReader, StringReader`

public abstract class Reader extends java.lang.Object implements java.lang.AutoCloseable
Abstract class for reading character streams. The only methods that a subclass must implement are read(char[], int, int) and close(). Most subclasses, however, will override some of the methods defined here in order to provide higher efficiency, additional functionality, or both. Since: JDK1.1, CLDC 1.0 See Also:InputStreamReader, Writer

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `protected java.lang.Object`
  `lock`
  The object used to synchronize operations on this stream.

- ## Constructor Summary

  Constructors
  Modifier
  Constructor
  Description
  `protected`
  `Reader()`
  Create a new character-stream reader whose critical sections will synchronize on the reader itself.
  `protected`
  `Reader(java.lang.Object lock)`
  Create a new character-stream reader whose critical sections will synchronize on the given object.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `abstract void`
  `close()`
  Close the stream.
  `void`
  `mark(int readAheadLimit)`
  Mark the present position in the stream.
  `boolean`
  `markSupported()`
  Tell whether this stream supports the mark() operation.
  `int`
  `read()`
  Read a single character.
  `int`
  `read(char[] cbuf)`
  Read characters into an array.
  `abstract int`
  `read(char[] cbuf, int off, int len)`
  Read characters into a portion of an array.
  `boolean`
  `ready()`
  Tell whether this stream is ready to be read.
  `void`
  `reset()`
  Reset the stream.
  `long`
  `skip(long n)`
  Skip characters.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Field Details

  - ### lock

    protected java.lang.Object lock
    The object used to synchronize operations on this stream. For efficiency, a character-stream object may use an object other than itself to protect critical sections. A subclass should therefore use the object in this field rather than this or a synchronized method.

- ## Constructor Details

  - ### Reader

    protected Reader()
    Create a new character-stream reader whose critical sections will synchronize on the reader itself.

  - ### Reader

    protected Reader(java.lang.Object lock)
    Create a new character-stream reader whose critical sections will synchronize on the given object. lock - The Object to synchronize on.

- ## Method Details

  - ### close

    public abstract void close() throws IOException
    Close the stream. Once a stream has been closed, further read(), ready(), mark(), or reset() invocations will throw an IOException. Closing a previously-closed stream, however, has no effect.
    Specified by:
      `close` in interface `java.lang.AutoCloseable`
    Throws:
      `IOException`

  - ### mark

    public void mark(int readAheadLimit) throws IOException
    Mark the present position in the stream. Subsequent calls to reset() will attempt to reposition the stream to this point. Not all character-input streams support the mark() operation.
    Throws:
      `IOException`

  - ### markSupported

    public boolean markSupported()
    Tell whether this stream supports the mark() operation. The default implementation always returns false. Subclasses should override this method.

  - ### read

    public int read() throws IOException
    Read a single character. This method will block until a character is available, an I/O error occurs, or the end of the stream is reached. Subclasses that intend to support efficient single-character input should override this method.
    Throws:
      `IOException`

  - ### read

    public int read(char[] cbuf) throws IOException
    Read characters into an array. This method will block until some input is available, an I/O error occurs, or the end of the stream is reached.
    Throws:
      `IOException`

  - ### read

    public abstract int read(char[] cbuf, int off, int len) throws IOException
    Read characters into a portion of an array. This method will block until some input is available, an I/O error occurs, or the end of the stream is reached.
    Throws:
      `IOException`

  - ### ready

    public boolean ready() throws IOException
    Tell whether this stream is ready to be read.
    Throws:
      `IOException`

  - ### reset

    public void reset() throws IOException
    Reset the stream. If the stream has been marked, then attempt to reposition it at the mark. If the stream has not been marked, then attempt to reset it in some way appropriate to the particular stream, for example by repositioning it to its starting point. Not all character-input streams support the reset() operation, and some support reset() without supporting mark().
    Throws:
      `IOException`

  - ### skip

    public long skip(long n) throws IOException
    Skip characters. This method will block until some characters are available, an I/O error occurs, or the end of the stream is reached.
    Throws:
      `IOException`